;Hook code

 include "settings.inc"
 include "ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON

 EXTERN PutSApp,IGetKey,DispHexA,DispHexArray,loadAppVar,IPutS,DispHexHL,translatePage

silentLinkHook:
       add a,e
       call loadAppVar
       ld a,(appData)
       or a
       jr nz,$F
       or 1
       ret
$$:    cp 1
       jr z,silentLinkHandler
       ld hl,silentLinkHandler
       call APP_PUSH_ERRORH
       res 1,(iy+1Bh)
       res 2,(iy+1Bh)
       res 3,(iy+1Bh)
       res 4,(iy+1Bh)
       cp 2
       jr nz,$F
       ld e,0
       in a,(0)
       set 0,(iy+3Eh)
       B_CALL RejectCommand
       jr abortSilentLink
$$:    cp 3
       jr z,startTransfer
       cp 5
       jr z,startTransfer_1
       in a,(0)
       B_CALL ContinueGetByte
runProgramFromAppVar:
       bit editOpen,(iy+editFlags)
       jr nz,abortSilentLink
       ld hl,appData
       rst 20h
       ld a,ProgObj
       ld (OP1),a
       B_CALL ChkFindSym
       jr c,abortSilentLink
       ld a,b
       or a
       jr nz,abortSilentLink
       ex de,hl
       B_CALL ldhlind
       push hl
       B_CALL EnoughMem
       pop hl
       jr c,abortSilentLink
       ld de,userMem
       push hl
       B_CALL InsertMem
       call userMem
       pop de
       ld hl,userMem
       B_CALL DelMem
       jr abortSilentLink
startTransfer:
       in a,(0)
       B_CALL ContinueGetByte
startTransfer_1:
       B_CALL Get3Bytes
startTransfer_2:
       ld a,(header+1)
       cp 29h
       jr z,setLockdown
       cp 2Ah
       jr z,resetLockdown
       cp 2Bh
       jr z,setKeyEcho
       cp 2Ch
       jr z,resetKeyEcho
       cp 92h
       jr z,sendAckAndEnd
       cp 6Dh
       jr z,sendScreenshot
       cp 87h
       jr z,forceKeyPress
       cp 89h
       jr z,remoteProgramExecution
       cp 06h
       jr z,receiveVarHeader
       cp 68h
       jr nz,abortSilentLink
ackAndGetNextPacket:
       B_CALL SendAck
       B_CALL Get4BytesNC
       jr startTransfer_2
setKeyEcho:
       set 5,(iy+33h)
       jr sendAckAndEnd
resetKeyEcho:
       res 5,(iy+33h)
       jr sendAckAndEnd
setLockdown:
       res 4,(iy+33h)
       jr sendAckAndEnd
resetLockdown:
       ld a,7Bh
       call translatePage
       ld hl,_RejectCommand
       ld de,OP1
       ld bc,3
       B_CALL FlashToRam
       ld hl,(OP1)
       ld (9B78h),hl
       ld a,(OP1+2)
       ld (9B7Ah),a
       set 3,(iy+33h)
       set 4,(iy+33h)
       jr sendAckAndEnd
sendScreenshot:
       B_CALL SendScreenContents
       jr abortSilentLink
FinishReceivingDataPacket:
       ld bc,(header+2)
$$:    push bc
       B_CALL RecAByteIO
       pop bc
       dec bc
       ld a,b
       or c
       jr nz,$B
       B_CALL RecAByteIO
       B_CALL RecAByteIO
       ret
remoteProgramExecution:
       B_CALL GetSmallPacket
       B_CALL SendAck
       ld a,(appData)
       cp 5
       jr nz,abortSilentLink ;actually, run the program it sent
       jr runProgramFromAppVar
forceKeyPress:
       ld a,(header+2)
       B_JUMP JForceCmd
receiveVarHeader:
       B_CALL GetSmallPacket
       ld h,09h
       B_CALL Send4BytePacket
       B_CALL Get4BytesNC
       call FinishReceivingDataPacket
       jr ackAndGetNextPacket
sendAckAndEnd:
       B_CALL SendAck
abortSilentLink:
       call APP_POP_ERRORH
silentLinkHandler:
       res indicOnly,(iy+indicFlags)
       xor a
       ret
